/**
 * The main entrypoint when using Bun as the runtime
 */

import {enableRawMode} from './ffi'

export async function main(): Promise<number> {
	const disableRawMode = enableRawMode();

	const decoder = new TextDecoder();
	for await (const chunk of Bun.stdin.stream()) {
		const char = String(decoder.decode(chunk)).trim();

		if (char === 'q') {
			disableRawMode();
			return 0;
		}
	}

	process.on("exit", (code) => {
		console.log(`Process exited with code ${code}`);
		disableRawMode();
	});

	return -1;
}